#include <stdio.h>
#include <termio.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/timeb.h>
#include <fcntl.h>
#include <stdlib.h>

int f;

//char *logo = "Welcome to Atari Linux workstation!\n";
//char *logo = "1234567890\n";

void raw( void )
{
struct termios it;

if (tcgetattr(f,&it)<0) err( "get attr" );
it.c_lflag &= 0; //~(ICANON|ISIG|ECHO);
it.c_iflag &= 0; // ~(INPCK|ISTRIP|IXON);
//it.c_iflag |= IGNPAR;
it.c_oflag &=0; // ~(OPOST);
it.c_cc[VMIN] = 1;
it.c_cc[VTIME] = 0;

if (cfsetospeed( &it, B19200 )<0) err( "set o speed" );
if (cfsetispeed( &it, B19200 )<0) err( "set i speed" );
if (tcsetattr(f,TCSANOW,&it)<0) err( "set attr" );
}


int main(int argc, char *argv[])
{
    char c;
    int i;
    FILE *inf;
    
    printf("Open COM2:\n");
    f = open("/dev/cua1", O_RDWR);
    if (!f) {
	printf("COM2: error!\n");
	exit(-1);
    } else printf(":\n");
    raw();
    inf = fopen(argv[1], "rb");
    fseek(inf, 0, SEEK_END);
    i=ftell(inf)+0x100-1;
    printf( "Reset Pyldin and boot from RS232:\n"
	    "100.%xi [RETURN]\n"
    	    "press enter for start boot\n", i);
    getchar();
    fseek(inf, 0, SEEK_SET);
    i=0;
    while (fread(&c, 1, 1, inf) == 1) {
	write(f, &c, 1);
	usleep(300);
    }
    fclose(inf);
    close(f);
}
